// ex 1.2 -> example 1 -> verify the Cauchy-Schwarz Inequality

clc
clear

// initializing and assigning vectors
x = [-1,4,2,0,-3];
y = [2,1,-4,-1,0];

// calculating dot product of x and y
x_y_dot = sum(x.*y);

disp('|x.y| =', abs(x_y_dot));

// calculating magnitude of vecors
x_norm = norm(x);
y_norm = norm(y);

// calculating x_norm*y_norm
norm_product = x_norm*y_norm;

// Answer varies due to round off error
disp('|x|*|y| =', norm_product);

if abs(x_y_dot) <= norm_product then
    disp('Cauchy-Schwarz Inequality verified as |x.y| <= |x|*|y|');
else
    disp('Cauchy-Schwarz Inequality not verified');
end
