// ex 1.2 -> example 5 -> parallel vectors

clc
clear

// initializing and assigning vectors
x = [8,-20,4];
y = [6,-15,3];

disp('vectors are', x, 'and', y);

// If vectors are parallel, the dot product of vectors will be 0. As cos0 = 0. Since the angle between the vectors is 0
// dot product of vectors
x_y_dot = sum(x.*y);

// magnitude of vectors
x_norm = norm(x);
y_norm = norm(y);

// product of magnitude of vectors
norm_product = x_norm*y_norm;

// calculating angle
// x.y = |x|*|y|*cos(theta)

theta = round(acos(x_y_dot/norm_product)); // rounding off to nearest integer

if theta == 0 then
    disp('Vectors are parallel');
else
    disp('Vectors are not parallel');    
end

