// complex matrices

clc
clear

// defining matrix
H = [3, 2-%i, 1-2*%i; 2+%i, -1, -3*%i; 1+2*%i, 3*%i, 4];
disp('H =', H);

// finding matrix transpose
H_transpose = H';
disp('H transpose =', H_transpose);

if H'==H then
    disp('Matrix is hermitian as H∗ = H');
end

disp('conjugate of H is', conj(H));
disp('H∗ is', H_transpose);

// defining matrix
K = [-2*%i, 5+%i, -1-3*%i; -5+%i, %i, 6; 1-3*%i, -6, 3*%i];
disp('K =', K);

// finding matrix transpose
K_transpose = K';
disp('H transpose =', K_transpose);

if K'==-K then
    disp('Matrix is skew-hermitian as K∗ = -K');
end 

disp('conjugate of K is', conj(K));
disp('H∗ is', K_transpose);
